def temp-table tt field f1 as integer field f11 as integer
                  index idx1 f1.
def temp-table tt2 field f2 as integer field f22 as integer
                  index idx2 f2.
def temp-table tt3 field f3 as integer field f33 as integer
                  index idx3 f3.

// ======================= SINGLE-TABLE FOR =======================

// for record phrase with implicit sort
for each tt:
    message tt.f1.
end.
// implicit sort => adaptive query


// for record phrase with explicit sort
for each tt by f1:
    message tt.f1.
end.
// explicit sort with index => adaptive query

// for record phrase with explicit sort on unindexed field
for each tt by f11:
    message tt.f1.
end.
// explicit sort without index => preselect query

// for record phrase with first and explicit sort
for first tt by f1:
    message tt.f1.
end.
// single-table first => random access query

// for record phrase with first and explicit sort by unindexed field
for last tt by f11:
    message tt.f1.
end.
// single-table last => random access query

// ======================= MULTI-TABLE NO-SORT FIRST/LAST FOR ======================= 

// multi-table for record phrase with implicit sort last/last
for last tt, last tt2:
    message tt.f1.
end.
// single record access => random access query

// multi-table for record phrase with implicit sort each/last
for each tt, last tt2:
    message tt.f1.
end.
// multi-table with implicit index => compound query => adaptive query !!!

// multi-table for record phrase with implicit sort last/first
for last tt, first tt2:
    message tt.f1.
end.
// single record access => random access query

// multi-table for record phrase with implicit sort first/each
for first tt, each tt2:
    message tt.f1.
end.
// multi-table with implicit index => compound query => adaptive query !!!

// ======================= MULTI-TABLE SORT EACH FOR =======================

// multi-table for record phrase with explicit sort on first table
for each tt, each tt2 by f1:
    message tt.f1.
end.
// multi-table with sort on indexed field of first table => compound query => adaptive query !!!

// multi-table for record phrase with explicit sort on first table and unindexed
for each tt, each tt2 by f11:
    message tt.f1.
end.
// multi-table with sort on unindexed field of first table => compound query => adaptive query !!!

// multi-table for record phrase with explicit sort on second table
for each tt, each tt2 by f2:
    message tt.f1.
end.
// multi-table with sort on field of second table => preselect query

// multi-table for record phrase with explicit sort on second table and unindexed
for each tt, each tt2 by f22:
    message tt.f1.
end.
// multi-table with sort on field of second table => preselect query

// ======================= MULTI-TABLE SORT FIRST/LAST FOR =======================

// multi-table for record phrase with explicit sort on first table each/last
for each tt, last tt2 by f1:
    message tt.f1.
end.
// multi-table with sort on first table + each/last => compound query => adaptive query !!!

// multi-table for record phrase with explicit sort on first table last/each unindexed
for last tt, each tt2 by f11:
    message tt.f1.
end.
// multi-table with sort on first table unindexed + each/last => compound query => adaptive query !!!

// multi-table for record phrase with explicit sort on second table each/first
for each tt, first tt2 by f2:
    message tt.f1.
end.
// multi-table with sort on second table => preselect query

// multi-table for record phrase with explicit sort on second table first/each unindexed
for first tt, each tt2 by f22:
    message tt.f1.
end.
// multi-table with sort on second table => preselect query