def temp-table tt field f1 as integer field f11 as integer
                  index idx1 f1.
def temp-table tt2 field f2 as integer field f22 as integer
                  index idx2 f2.

function fnc returns integer(input x as integer):
    return x + 2.
end.

// ======================== FOR CLIENT WHERE ========================

//compound (adaptive + adaptive)
open query q1 for each tt, each tt2 where fnc(tt.f1) = 2. // 0, tt

//adaptive
open query q1 for each tt where fnc(tt.f1) = 2, each tt2. // tt, 0

//compound (preselect, adaptive)
open query q1 for each tt where fnc(tt.f1) = 2, each tt2 where fnc(tt.f1) = 2. //tt, tt

//adaptive
open query q1 for each tt where fnc(tt.f1) = 2, each tt2 where fnc(tt2.f2) = 2. // tt, tt2

//adaptive
open query q1 for each tt, each tt2 where fnc(tt2.f2) = 2. //0, tt2


// ======================== PRESELECT CLIENT WHERE ========================


//compound (preselect + preselect)
open query q1 preselect each tt, each tt2 where fnc(tt.f1) = 2. // 0, tt

//preselect
open query q1 preselect each tt where fnc(tt.f1) = 2, each tt2. // tt, 0

//compound (preselect, preselect)
open query q1 preselect each tt where fnc(tt.f1) = 2, each tt2 where fnc(tt.f1) = 2. //tt, tt

//preselect
open query q1 preselect each tt where fnc(tt.f1) = 2, each tt2 where fnc(tt2.f2) = 2. // tt, tt2

//preselect
open query q1 preselect each tt, each tt2 where fnc(tt2.f2) = 2. //0, tt2


// ======================== FOR WHERE ========================


//compound (adaptive + adaptive)
open query q1 for each tt, each tt2 where tt.f1 = 2. // 0, tt

//adaptive
open query q1 for each tt where tt.f1 = 2, each tt2. // tt, 0

//compound (preselect, adaptive)
open query q1 for each tt where tt.f1 = 2, each tt2 where tt.f1 = 2. //tt, tt

//adaptive
open query q1 for each tt where tt.f1 = 2, each tt2 where tt2.f2 = 2. // tt, tt2

//adaptive
open query q1 for each tt, each tt2 where tt2.f2 = 2. //0, tt2


// ======================== COMBINED CLIENT+WHERE ========================

//adaptive
open query q1 for each tt where fnc(tt.f1) = 2 and tt.f1 = 2, each tt2.

//compound (adaptive + adaptive)
open query q1 for each tt, each tt2 where fnc(tt.f1) = 2 and tt.f1 = 2.

//compound (adaptive + adaptive)
open query q1 for each tt where fnc(tt.f1) = 2 and tt.f1 = 2, each tt2 where fnc(tt.f1) = 2 and tt.f1 = 2.

//adaptive
open query q1 for each tt, each tt2 where fnc(tt2.f2) = 2 and tt2.f2 = 2.

//compond (adaptive + adaptive)
open query q1 for each tt, each tt2 where fnc(tt2.f2) = 2 and tt.f1 = 2.

//compound (adaptive + adaptive)
open query q1 for each tt, each tt2 where fnc(tt.f1) = 2 and tt2.f2 = 2.

//adaptive
open query q1 for each tt where fnc(tt.f1) = 2 and tt.f1 = 2, each tt2 where fnc(tt2.f2) = 2 and tt2.f2 = 2.

//compound (adaptive+adaptive)
open query q1 for each tt where fnc(tt.f1) = 2 and tt.f1 = 2, each tt2 where fnc(tt.f1) = 2 and tt2.f2 = 2.

//compound (adaptive+adaptive)
open query q1 for each tt where fnc(tt.f1) = 2 and tt.f1 = 2, each tt2 where fnc(tt2.f2) = 2 and tt.f1 = 2.